do
	local Prefs = import('/lua/user/prefs.lua')
	local options = Prefs.GetFromCurrentProfile('options')
	if options.gui_scu_manager != 0 then
		local originalCreateUI = CreateUI
		function CreateUI(isReplay)
		    originalCreateUI(isReplay)
			import("/mods/GUI/modules/scumanager.lua").Init()
		end
	end
	
	local originalOnSelectionChanged = OnSelectionChanged

	function OnSelectionChanged(oldSelection, newSelection, added, removed)
		--run old selection code
		originalOnSelectionChanged(oldSelection, newSelection, added, removed)

		local selUnits = newSelection
		if selUnits	and table.getn(selUnits) == 1 and (Prefs.GetFromCurrentProfile('range_RenderSingleSelected') or Prefs.GetFromCurrentProfile('range_RenderSingleSelected') == nil) then
			import("/mods/gui/modules/selectedinfo.lua").ActivateSingleRangeOverlay()
		else
			import("/mods/gui/modules/selectedinfo.lua").DeactivateSingleRangeOverlay()
		end   
	end

	import('/mods/GUI/modules/keymapping.lua').Init()
end
