do
	local Prefs = import('/lua/user/prefs.lua')
	local options = Prefs.GetFromCurrentProfile('options')
	if options.gui_scu_manager != 0 then
		local originalUpdateWindow = UpdateWindow
		function UpdateWindow(info)
			originalUpdateWindow(info)
			controls.SCUType:Hide()
			if info.userUnit.SCUType then
				controls.SCUType:SetTexture('/mods/GUI/textures/scumanager/'..info.userUnit.SCUType..'_icon.dds')
				controls.SCUType:Show()
			end
		end	
		
		local originalCreateUI = CreateUI
		function CreateUI()
			originalCreateUI()
			controls.SCUType = Bitmap(controls.bg)
			LayoutHelpers.AtRightIn(controls.SCUType, controls.icon)
			LayoutHelpers.AtBottomIn(controls.SCUType, controls.icon)
		end
	end

	if options.gui_enhanced_unitview != 0 then
		local originalCreateUI = CreateUI
		local originalUpdateWindow = UpdateWindow
		function CreateUI()
			originalCreateUI()
			local oldBGOnFrame = controls.bg.OnFrame
			controls.bg.OnFrame = function(self, delta)
				local info = GetRolloverInfo()
				-- If no rollover, then see if we have a single unit selected
				if not info and import("/mods/GUI/modules/selectedinfo.lua").SelectedInfoOn then
					local selUnits = GetSelectedUnits()
					if selUnits and table.getn(selUnits) == 1 and import('/lua/ui/game/unitviewDetail.lua').View.Hiding then
						info = import("/mods/GUI/modules/selectedinfo.lua").GetUnitRolloverInfo(selUnits[1])
				--LOG(repr(import('/lua/enhancementcommon.lua').GetEnhancements(info.entityId)))
					end
				end
				-- Original function code
		        if info then
		            UpdateWindow(info)
		            if self:GetAlpha() < 1 then
		                self:SetAlpha(math.min(self:GetAlpha() + (delta*3), 1), true)
		            end
		            import(UIUtil.GetLayoutFilename('unitview')).PositionWindow()
		        elseif self:GetAlpha() > 0 then
		            self:SetAlpha(math.max(self:GetAlpha() - (delta*3), 0), true)
		        end
			end
		end

		function UpdateWindow(info)
			originalUpdateWindow(info)
			-- Replace fuel bar with progress bar
			if info.blueprintId ~= 'unknown' then
				controls.fuelBar:Hide()
				if info.workProgress > 0 then
					controls.fuelBar:Show()
					controls.fuelBar:SetValue(info.workProgress)
				end
			end
		end
	end
end
